/* Problem URL: https://codeforces.com/contest/598/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, k;
    cin >> n >> m >> k;

    V<string> fds(n);
    cin >> fds;

    V<V<bool>> vis(n, V<bool>(m));

    function<int(int, int)> dfs = [&](int i, int j) {
        if (fds[i][j] == '*') {
            return 1;
        }

        vis[i][j] = true;

        int ans = 0;

        int add[][2] = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
        repv(k, add) {
            int id = i + k[0];
            int jd = j + k[1];
            if (id >= 0 && id < n && jd >= 0 && jd < m && !vis[id][jd]) {
                ans += dfs(id, jd);
            }
        }

        return ans;
    };

    vvi ans(n, vi(m));

    function<void(int, int, int)> flood = [&](int i, int j, int v) {
        fds[i][j] = '*';
        ans[i][j] = v;

        int add[][2] = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
        repv(k, add) {
            int id = i + k[0];
            int jd = j + k[1];
            if (id >= 0 && id < n && jd >= 0 && jd < m && fds[id][jd] == '.') {
                flood(id, jd, v);
            }
        }
    };

    rep(i, n) {
        rep(j, m) {
            if (fds[i][j] == '.' && !vis[i][j]) {
                int tmp = dfs(i, j);
                flood(i, j, tmp);
            }
        }
    }

    while (k--) {
        int i, j;
        cin >> i >> j;
        cout << ans[i - 1][j - 1] << '\n';
    }
}
